package scalapi.jdk.net

import java.net.BindException

object Sockets {

  val unixMaxReservedPort = 1024

  val unixFirstNotReservedPort = unixMaxReservedPort + 1

  def findAvailablePort[T](serverCreator: Int => T): T = {
    var server = null.asInstanceOf[T]
    var port = unixFirstNotReservedPort
    var portFound = false
    while (!portFound) {
      try {
        server = serverCreator(port)
        portFound = true
      } catch {
        case e: BindException => port = port + 1
      }
    }
    server
  }

}
